# Evaluates an expression; writes s if there is no expression.
x <- function( s ) {
  return(
    tryCatch({
      r = eval( parse( text=s ) )

      # If the result isn't primitive, then it was probably parsed into
      # an unprintable object (e.g., "gray" becomes a colour). In those
      # cases, return the original text string. Otherwise, an atomic
      # value means a primitive type (string, integer, etc.) that can be
      # written directly into the document.
      if( is.null( r ) ) {
        s
      }
      else if( is.atomic( r ) ) {
        r
      }
      else {
        s
      }
    },
    warning = function( w ) {
      s
    },
    error = function( e ) {
      s
    })
  )
}

